apiVersion: build.openshift.io/v1
kind: BuildConfig
metadata:
  annotations:
    description: Parses HTTP Notifications
  name: routing-jenkins-pipeline
  namespace: {{ namespace }}
spec:
  strategy:
    jenkinsPipelineStrategy:
      jenkinsfile: |-
        pipeline {
            agent any
            options { timeout(time: 5, unit: 'MINUTES') }
            parameters {
{% if gitea_api_address | default(False) %}
                string(defaultValue: '{{ gitea_api_address | urlsplit('hostname') }}', description: 'Default Git Repository', name: 'defaultGit')
{% elif gogs_api_address | default(False) %}
                string(defaultValue: '{{ gogs_api_address | urlsplit('hostname') }}', description: 'Default Git Repository', name: 'defaultGit')
{% elif gerrit_api_address | default(False) %}
                string(defaultValue: '{{ gerrit_api_address | urlsplit('hostname') }}', description: 'Default Git Repository', name: 'defaultGit')
{% else %}
                string(defaultValue: '{{ default_git_server | default('github.com') }}', description: 'Default Git Repository', name: 'defaultGit')
{% endif %}
                string(defaultValue: 'yes', description: 'Forces Reloading Pipelines Definition', name: 'doReloadPipeline')
                string(defaultValue: 'ci.{{ root_domain }}', description: 'OpenShift CI Root DNS Record', name: 'rootDomain')
            }
            triggers {
                GenericTrigger(
                        causeString: 'Triggered on $ref',
                        genericVariables: [
                                [key: 'after', value: '$.after'],
                                [key: 'projectgitlab', value: '$.project.git_ssh_url'],
                                [key: 'projectgitea', value: '$.repository.ssh_url'],
                                [key: 'ref', value: '$.ref']
                            ],
                        printContributedVariables: true,
                        printPostContent: true,
                        regexpFilterExpression: '.*',
                        regexpFilterText: '.*',
                        silentResponse: false,
                        token: '{{ (jenkins_trigger_token.resources[0].data['password'] | default('')) | b64decode }}'
                    )
            }
            stages {
                stage('Parse Notification') {
                    steps {
                        script {
                            openshift.withCluster() {
                                openshift.withProject() {
                                    def branch     = "master"
                                    def exact      = ""
                                    def namespace  = "${openshift.project()}"
                                    def url        = ""
                                    echo "Using project: ${namespace}"
                                    try {
                                        url = "${projectgitlab}"
                                        echo "Notified GitLab repository: ${projectgitlab}"
                                    } catch(e) {
                                        try {
                                            url = "${projectgitea}"
                                            echo "Notified Gitea/Gogs repository: ${projectgitea}"
                                        } catch(e2) {
                                            echo "missing repository info / unsupported notification format"
                                            throw e2
                                        }
                                    }
                                    try {
                                        String refs = "${ref}"
                                        if (refs != "") {
                                            println "Found ref: $refs"
                                            String[] arrBranch = refs.split("/")
                                            if (arrBranch.size() > 1) { branch = arrBranch[2] }
                                        }
                                    } catch(e) { echo "Assuming default branch" }
                                    try {
                                        echo "Notified hash: ${after}"
                                        exact = "${after}"
                                    } catch(e) {
                                        echo "missing hash, assuming ${branch}"
                                        exact = "${branch}"
                                    }
                                    def repoUrl = url.replaceFirst(/(git|git+ssh|ssh|http|https):\/\/((gitea|gogs|git|www-data)@|)/, "").replaceFirst(/:(2022|2222|3000|443|8080)/, "")
                                    echo "Pulling from: ${repoUrl}#$exact"
                                    def repoHost = repoUrl.split('/')[0]
                                    def repoName = repoUrl.replace("${repoHost}/", "")
                                    def component = repoName.replaceFirst(/^.*(docker|s2i)-/, "").replace(".git", "").replaceAll("-", "")
                                    echo "  with repoHost:${repoHost}, repoName:${repoName}, component:${component}"
                                    def folder    = "${namespace}-${component}-jenkins-pipeline"
                                    def jobName   = "${namespace}/${folder}"
                                    def jobParams = [
                                            [$class: 'StringParameterValue', name: "buildBranch", value: branch],
                                            [$class: 'StringParameterValue', name: "buildHash", value: exact],
                                            [$class: 'StringParameterValue', name: "buildRepo", value: repoUrl]
                                        ]
                                    currentBuild.description = """
                                    ${repoHost} ${repoName} ${branch}
                                    processing ${exact}
                                    """.stripIndent()
                                    try {
                                        sh "test -s ${env.JENKINS_HOME}/jobs/${namespace}/jobs/${folder}/config.xml"
                                        if (params.doReloadPipeline == 'yes') { throw "forced reload" }
                                    } catch(e) {
                                        sh "rm -fr tmpocp; mkdir -p tmpocp"
                                        def templatePath = "${env.JENKINS_HOME}/jobs/${namespace}/jobs/${namespace}-routing-jenkins-pipeline/workspace/tmpocp${component}${exact}/openshift/ci.yaml"
                                        def privateRepo  = false
                                        dir ("tmpocp${component}${exact}") {
                                            try {
                                                withCredentials([string(credentialsId: "git-${repoHost}", variable: 'GIT_TOKEN')]) {
                                                    sh "git config --global http.sslVerify false"
                                                    privateRepo = true
                                                    echo "cloning ${repoUrl} over https, using ${repoHost} token"
                                                    try { git([ branch: "${branch}", changelog: false, poll: false, url: "https://${GIT_TOKEN}@${repoUrl}" ]) }
                                                    catch(e2) {
                                                        echo "caught ${e2} - failed cloning ${repoUrl}#${branch}"
                                                        sh "cd .. ; rm -fr tmpocp${component}${exact}"
                                                        throw e2
                                                    }
                                                }
                                            } catch(e1) {
                                                if (privateRepo != true) {
                                                    echo "cloning ${repoUrl} over http"
                                                    try { git([ branch: "${branch}", changelog: false, poll: false, url: "http://${repoUrl}" ]) }
                                                    catch(e2) {
                                                        echo "caught ${e2} - failed cloning ${repoUrl}#${branch}"
                                                        sh "cd .. ; rm -fr tmpocp${component}${exact}"
                                                        throw e2
                                                    }
                                                } else { throw e1 }
                                            }
                                            try {
                                                if (exact != branch) {
                                                    echo "checking out to ${exact}"
                                                    sh "git checkout ${exact}"
                                                }
                                            } catch(e1) { echo "sticking with ${branch} - ${e1}" }
                                            try { sh "test -s ${templatePath}" }
                                            catch (e1) {
                                                echo "Could not find ${templatePath} in ${repoUrl}#${branch}"
                                                sh "cd .. ; rm -fr tmpocp${component}${exact}"
                                                throw e1
                                            }
                                            try {
                                                echo "Loading Jenkinsfile template from ${templatePath}"
                                                def templateArgs = [ "-f", "${templatePath}" ]
                                                try {
                                                    sh "grep OPENSHIFT_ROUTED_DOMAIN ${templatePath} >/dev/null"
                                                    templateArgs.push("-p")
                                                    templateArgs.push("OPENSHIFT_ROUTED_DOMAIN=${params.rootDomain}")
                                                } catch(e2) { "no routed domain param" }
                                                try {
                                                    sh "grep GIT_SOURCE_HOST ${templatePath} >/dev/null"
                                                    templateArgs.push("-p")
                                                    templateArgs.push("GIT_SOURCE_HOST=${params.defaultGit}")
                                                } catch(e2) { "no git host param" }
                                                def objectsFromTemplate = openshift.process(templateArgs.join(' '))
                                                echo "operation will apply ${objectsFromTemplate.size()} objects"
                                                for (o in objectsFromTemplate) { o.metadata.labels["jenkins-ci"] = "${namespace}" }
                                                def created = openshift.apply(objectsFromTemplate)
                                                created.withEach { echo "Created ${it.name()} with labels ${it.object().metadata.labels}" }
                                            } catch (e1) {
                                                echo "Failed creating job ${jobName} - ${e1}"
                                                sh "cd .. ; rm -fr tmpocp${component}${exact}"
                                            }
                                        }
                                        sh "rm -fr tmpocp${component}${exact}"
                                    }
                                    try { sh "test -s ${env.JENKINS_HOME}/jobs/${namespace}/jobs/${folder}/config.xml" }
                                    catch(e) {
                                        echo "Could not find job ${jobName}"
                                        throw e
                                    }
                                    try { build job: "${jobName}", parameters: jobParams, propagate: false, wait: false }
                                    catch(e) { echo "${e}" }
                                    echo "Scheduled job $jobName"
                                }
                            }
                        }
                    }
                }
            }
        }
    type: JenkinsPipeline
